(*************** test framework ********************)

let draw_circle a b r=
   for i=0 to 300 do
      let t= 0.01 *. (float i) in
      let x= int_of_float(a +. r *. (cos t)) and
          y= int_of_float(b +. r *. (sin t)) in
             Graphics.plot x y
    done
;;

let draw_circle msk s=
  let xs= Wid.getFloatList (Wid.get_fields msk s) in
     match xs with
        (a::b::r::more) -> draw_circle a b r; s
      | other -> "Error"
;;

let main () = 
        Wid.open_gr "Draw Circle"; 
        let msk= Wid.the_mask [ "Centro: (###,###)             ";
                                "Raio: ##                      "] in
        let ed = Wid.mk_entry ~txt:msk ~mask:(Wid.mask_fun msk) ~fn:(draw_circle msk) "Cculo"  
        and ext= Wid.exit_button()   
        and uppr= Wid.gbutton 0 "um.nss" "tres.nss" (fun () -> Wid.clear_graph()) "Uppercase" 
        in
         while true do
               ed.Wid.process_event ();
               ext.Wid.process_event();
               uppr.Wid.process_event();
               Wid.refresh ()
         done;
         Wid.close_gr()
;;   
 
main ();;   