let rec list_to_str list = match list with
	[] -> ""
	|x::xs -> x ^ (";") ^ (list_to_str xs)

let find_answer d temps =
	let compare_label d t =
	   let rec loop i = match i with
		n when (n >= String.length d) || (n >= String.length t) -> false
	      | n when d.[n] = ' ' && t.[n] = ' ' -> true
	      | n when d.[n] = t.[n] -> loop (i+1)
	      | n -> false in
	      loop 0 in
  let rec loop ts = match ts with
       [] -> ""
    | (t::t_rest) when compare_label d t -> t
    | (t::t_rest) -> loop t_rest in
       loop temps;; 


let compare templates editor ()=
   let answer=  Wid.get_contents editor in
   let correct=  find_answer answer templates in  
          if (Wid.getStringList (String.uppercase correct))= (Wid.getStringList (String.uppercase answer)) 
          then ( Wid.set_mask ("Correct. ") editor)
          else ( Wid.set_mask ("Wrong, try again.") editor);;

let  nxt_drill msk_fun templ editor () =
		Wid.set_mask (msk_fun ()) editor;;

let nxt_template  msk_fun templ editor  () =
		Wid.set_contents (templ ()) editor;;

(* just a shell to process the text with the mask *)
let processa s= s;;
let prepro msk s= s;;

let _ = 
	Wid.open_gr "Latin Declension";
	let    tps=  Wid.readMaskList "fstdecl.txt" in	
	let    msk= Wid.mask_circle (Wid.readMaskList "fstdecl.msk") and
	    	gbs= Wid.mask_circle tps  in
	let 	drill = Wid.mk_entry ~txt:(msk ()) ~fn:(fun x -> (String.uppercase x)) ~pp:prepro "Drill"  and
		template =  Wid.mk_edt ~txt:(gbs ()) "Template"  in
	let 	exit= Wid.exit_button() and
		nextTemplate= Wid.button 0 (nxt_drill msk gbs "Drill" ) "Drill" and
		nextDrill= Wid.button 1 (nxt_template msk gbs "Template" ) "Template" and
		chkButton= Wid.button 2 (compare tps  "Drill") "Correction" 
	in
	while true do
		Wid.refresh ();
		drill.Wid.process_event();
		template.Wid.process_event();
		nextTemplate.Wid.process_event();
		nextDrill.Wid.process_event();
		chkButton.Wid.process_event();
		exit.Wid.process_event()	
	done;
	Wid.close_gr();;