(*************** test framework ********************)

(* Example routine to modify the text to uppercase *)
let upc nm ()= 
	let xs= Wid.get_contents nm in
	let us= String.uppercase xs in
		Wid.set_contents us nm;;
(* Example routine to modify the text to lowercase *)
let toLower nm ()= 
	let xs= Wid.get_contents nm in
	let us= String.lowercase xs in
		Wid.set_contents us nm;;

(* Example routine to save the text to a file *)
let cnt= ref 0;;
let savit nm ()=
	let s= Wid.get_contents nm and
		chan= open_out (nm^".b"^(string_of_int !cnt)) in
	incr cnt;
	output_string chan s;
	close_out chan;;

(* Example routine to calculete the mean of a list of numbers *)
let avg s= 
	let rec loop nums acc c= match nums with
		  [] -> acc /. c
		| x::xs -> loop xs (acc +. x) (c +. 1.0) in
	loop s 0.0 0.0;;

(* returns just the numbers in float format *)
let rec rdThem s=
  try
    match Stream.next s with
      | Genlex.Int x -> (float_of_int x)::(rdThem s)
      | Genlex.Float x -> x::(rdThem s)
      | _  -> rdThem s
  with
     _ -> []
;;

(* get a list of float using ocamlex *)
let getFloatList s=
  let lex= Genlex.make_lexer [] in
    let strm= lex (Stream.of_string s) in
         rdThem strm
;;

(* process the text and return the text result *)
let find_avg s=
	let xs= getFloatList s in
		match xs with
			  [] -> "Empty list"
			| nums -> "The average is "^(string_of_float (avg nums));;

(* just a shell to process the text with the mask *)
let processa s= find_avg s;;


let main () = 
	Wid.open_gr "eMacs like Editor - Gui Example";
	let msk= Wid.the_mask ["Custo: #####\013Valor Venal: ###,###"; "Onda preta: #######     "] in
	let ed = Wid.mk_edt ~txt:(Wid.nlines 20) ~fn:(fun x -> (String.uppercase x)) "Editor 1"  and
		 ed1= Wid.mk_edt "Editor 2" and
		 ed2 = Wid.mk_entry ~txt:msk ~fn:processa "Editor 3"  in
	let ext= Wid.exit_button() and
		 uppr= Wid.gbutton 0 "um.nss" "tres.nss" (upc "Editor 1") "Uppercase" and
		 lc= Wid.button 1 (toLower "Editor 1") "Lowercase"  and
		 donothing= Wid.next_button_row 1 (fun s () -> ()) "Donothing"
	in
	
	while true do
	   Wid.refresh ();
		ed.Wid.process_event();
		ed1.Wid.process_event ();
		ed2.Wid.process_event (); 
		uppr.Wid.process_event();
		lc.Wid.process_event();
		donothing.Wid.process_event();
		
		ext.Wid.process_event()	
	done;
	Wid.close_gr();;   
 
main ();;